/*******************************************************************************
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2014. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  Use,
 * duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.apt.web.ui.internal.common.viewer.plan.gadgets.ViewportChangeHandler");

dojo.require("com.ibm.team.rtc.foundation.web.Destroyable");
dojo.require("com.ibm.team.rtc.foundation.web.ui.gadgets.table.ListenerCollection");
dojo.require("com.ibm.team.rtc.foundation.web.ui.util.DebounceOperation");
dojo.require("com.ibm.team.rtc.foundation.web.ui.util.Destroyables");
dojo.require("jazz.util.ResizeNotifier");

(function() {
var web= com.ibm.team.rtc.foundation.web;
var Destroyable= web.Destroyable;
var ui= web.ui;
var ListenerCollection= ui.gadgets.table.ListenerCollection;
var util= ui.util;
var DebounceOperation= util.DebounceOperation;
var Destroyables= util.Destroyables;
var ResizeNotifier= jazz.util.ResizeNotifier;

var ViewportChangeHandler= dojo.declare("com.ibm.team.apt.web.ui.internal.common.viewer.plan.gadgets.ViewportChangeHandler", Destroyable, {

	//_listeners: null,

	//_debounceUpdate: null,

	constructor: function() {
		this.inherited(arguments, []);
		this._listeners= new ListenerCollection();
		this._debounceUpdate= new DebounceOperation(150);
		this.own(Destroyables.fromHandle(dojo.connect(window, 'scroll', dojo.hitch(this, function(event) {
			this.update();
		}))));
		var handle= ResizeNotifier.register({callback: dojo.hitch(this, function() {
			this.update();
		}), browserEvents: true, force: true});
		this.own(Destroyables.wrap(dojo.hitch(this, function() {
			ResizeNotifier.unregister(handle);
			this._listeners= null;
		})));
	},

	update: function() {
		if (!this._listeners.hasListeners("com.ibm.team.apt.web.ui.internal.common.viewer.plan.gadgets.ViewportChangeHandler")) 
			return ;
		this._debounceUpdate.debounce(function() {
			ViewportChangeHandler.callListeners();
		});
	},

	releaseIfEmpty: function() {
		if (!this._listeners.hasListeners("com.ibm.team.apt.web.ui.internal.common.viewer.plan.gadgets.ViewportChangeHandler")) {
			ViewportChangeHandler.releaseInstance();
		}
	}
});

ViewportChangeHandler._debounceViewportChange= new DebounceOperation(150);
ViewportChangeHandler._instance= null;
ViewportChangeHandler.getInstance= function() {
	if (ViewportChangeHandler._instance == null) {
		ViewportChangeHandler._instance= new ViewportChangeHandler();
	}
	return ViewportChangeHandler._instance;
};
ViewportChangeHandler.notifyViewportHasChanged= function() {
	ViewportChangeHandler._debounceViewportChange.debounce(function() {
		ResizeNotifier.poke();
	});
};
ViewportChangeHandler.addListener= function(listener) {
	return ViewportChangeHandler.getInstance()._listeners.addListener("com.ibm.team.apt.web.ui.internal.common.viewer.plan.gadgets.ViewportChangeHandler", listener);
};
ViewportChangeHandler.removeListener= function(handle) {
	ViewportChangeHandler.getInstance()._listeners.removeListener(handle);
	ViewportChangeHandler.getInstance().releaseIfEmpty();
};
ViewportChangeHandler.callListeners= function() {
	ViewportChangeHandler.getInstance()._listeners.callListeners("com.ibm.team.apt.web.ui.internal.common.viewer.plan.gadgets.ViewportChangeHandler", null);
};
ViewportChangeHandler.isNodeVisible= function(node) {
	var rect= node.getBoundingClientRect();
	if (rect.top >= 0 && rect.left >= 0 && rect.top <= window.innerHeight && rect.left <= window.innerWidth) {
		return true;
	}
	return false;
};
ViewportChangeHandler.releaseInstance= function() {
	if (ViewportChangeHandler._instance != null) {
		ViewportChangeHandler._instance.destroy();
		ViewportChangeHandler._instance= null;
	}
};

})();
